<?php
/*
class CUserTableAccess extends CTblAccess{

	function CUserTableAccess() {
		$this->CTblAccess(USR_TBL);
	}

	function getDetailUserData ($conn, $id) {
		$condition = " WHERE id = '".$this->escapeSqlString($id)."' AND deleted = 0";
		$result = $this->getList("*", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result[0];
		}
	}
	function getDataByUsername($conn, $username) {
		$condition = " WHERE username = '".$this->escapeSqlString($username)."'";
		$result = $this->getList("*", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result[0];
		}
	}

	function getDataByEmail($conn, $email) {
		$condition = " WHERE email = '".$this->escapeSqlString($email)."'";
		$result = $this->getList("*", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result[0];
		}
	}

	function isModifiableMail ($conn, $email, $mid) {
	//ǡǽɤå
	//emailȥϡʣʤۤ褤Τ
		$condition = " WHERE email = '".$this->escapeSqlString($email)."'";
		$condition .= " AND id != '".$this->escapeSqlString($mid)."'";
		$result = $this->getList("*", $condition, $conn);
		if ($result <> false) {
			return false;
		}
		
		return true;
	}
	
	function isModifiableLogin ($conn, $login, $mid) {
	//ǡǽɤå
	//emailȥϡʣʤۤ褤Τ
		
		$condition = " WHERE username = '".$this->escapeSqlString($login)."'";
		$condition .= " AND id != '".$this->escapeSqlString($mid)."'";
		$result = $this->getList("*", $condition, $conn);
		if ($result <> false) {
			return false;
		}
		return true;
	}
	
	function insertUserDataExe($conn, $get_arr) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
		if (DB_TYPE=="postgres7") {
			$index_item = "id,";
			$this->last_id = "id";
			$index_value = "nextval('".USR_ID_SEQ."'), ";
		}

		$INS_ITEM = $index_item."confirmed,username,password, firstname, lastname, email";
		$INS_CON = $index_value;
//˥Ǥ褦ˡȤꤢconfirmed1ˤ
		$INS_CON .= "1, ";
		$INS_CON .= "'".$this->escapeSqlString($get_arr['username'])."', '";
		$INS_CON .= $this->escapeSqlString($get_arr['password'])."', '";
		$INS_CON .= $this->escapeSqlString($get_arr['firstname'])."', '";
		$INS_CON .= $this->escapeSqlString($get_arr['lastname'])."','".$this->escapeSqlString($get_arr['email'])."'";
		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}
	}

	function insertFromXExe($conn, $uname, $name, $pass, $email) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
		if (DB_TYPE=="postgres7") {
			$index_item = "id,";
			$this->last_id = "id";
			$index_value = "nextval('".USR_ID_SEQ."'), ";
		}

		$INS_ITEM = $index_item."confirmed,username,password, firstname, lastname, email,timemodified";
		$INS_CON = $index_value;
//˥Ǥ褦ˡȤꤢconfirmed1ˤ
		$INS_CON .= "1, ";
		$INS_CON .= "'".$this->escapeSqlString(mb_convert_encoding($uname,MHTML_ENCODE,XHTML_ENCODE))."', '";
		$INS_CON .= $this->escapeSqlString(mb_convert_encoding($pass,MHTML_ENCODE,XHTML_ENCODE))."', '";
		$INS_CON .= $this->escapeSqlString(mb_convert_encoding($name,MHTML_ENCODE,XHTML_ENCODE))."', '";
		$INS_CON .= $this->escapeSqlString(mb_convert_encoding($name,MHTML_ENCODE,XHTML_ENCODE))."','";
		$INS_CON .= $this->escapeSqlString(mb_convert_encoding($email,MHTML_ENCODE,XHTML_ENCODE))."',".time();
		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}
	}
	
	function updateUserDataExe($conn, $dat_arr) {
		//WHERE
		$where_st = "id = '".$this->escapeSqlString($dat_arr['up_id'])."'";
			//set
		$set_st = "username ='".$this->escapeSqlString($dat_arr['username'])."', ";
		$set_st = "password = '".$this->escapeSqlString($dat_arr['password'])."', ";
		$set_st .= "firstname ='".$this->escapeSqlString($dat_arr['firstname'])."', ";
		$set_st .= "lastname ='".$this->escapeSqlString($dat_arr['lastname'])."', ";
		$set_st .= "email ='".$this->escapeSqlString($dat_arr['email'])."'";

		if (!$this->upDat($set_st, $where_st, $conn)) {
			return false;
		} else {
			return true;
		}
	}
	
	function deleteUserDataExe($conn, $teacher_id) {
		//WHERE
		$where_st = "id = '".$teacher_id."'";
			//set
		$set_st = "deleted =1";

		if (!$this->upDat($set_st, $where_st, $conn)) {
			return false;
		} else {
			return true;
		}
	}
}

class CCourseTableAccess extends CTblAccess {
	var $maxsort;
	
	function CCourseTableAccess() {
		$this->CTblAccess (COURSE_TBL);
	}
	
	function setMaxSortOrder ($conn) {
		$want_col = "MAX(sortorder) AS maxsort";
		if (!$this->setSelectedList($want_col,"",$conn)) {
			return false;
		}
		$this->maxsort = $this->getSelectedList();
		return true;
	}
	function getMaxSortOrder () {
		return $this->maxsort[0][0];
	}
	
	function insertGroupExe($conn, $get_arr) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
		if (DB_TYPE=="postgres7") {
			$index_item = "id,";
			$this->last_id = "id";
			$index_value = "nextval('".COURSE_ID_SEQ."'), ";
		}
		//ȥΤ
		if (!$this->setMaxSortOrder($conn)) {
			return false;
		}
		$max_cat = intval($this->getMaxSortOrder()) +1;
		$INS_ITEM = $index_item."category,sortorder, fullname,summary";

		$INS_CON = $index_value;
		//ƥ꡼ϥǥեȤǡ¾褦ˤ
		$INS_CON .= MOCOU_DEF_CAT.", ".$max_cat.",'".$this->escapeSqlString($get_arr['fullname'])."','".$this->escapeSqlString($get_arr['summary'])."'";

		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}
	}

	function updateGroupDataExe($conn, $dat_arr, $group_id) {
		$where_st = "id = '".$this->escapeSqlString ($group_id)."'";
			//set
		$set_st = "fullname ='".$this->escapeSqlString ($dat_arr['fullname'])."', ";
		$set_st .= "short_name = '".$this->escapeSqlString ($dat_arr['shortname'])."'";
		
		if (!$this->upDat($set_st, $where_st, $conn)) {
			return false;
		} else {
			return true;
		}
	}
/*
	function getDetailGroupData($conn, $id) {
		$condition = " WHERE id = '".$this->escapeSqlString($id)."'";
		$result = $this->getList("*", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result[0];
		}
	}
	*//*
	function setDetailGroupData ($conn, $id) {
		$condition = " WHERE id = '".$this->escapeSqlString($id)."'";
		$result = $this->setSelectedList("*", $condition, $conn);
		if ($result == false) {
			return false;
		}
		return true;
	}
	
	function getDetailGroupData () {
		return $this->getSelectedList ();
	}
	
	function deleteGroupDataExe($conn, $id) {
		$condition = "id = '".$this->escapeSqlString($id)."'";
		if (!$this->delDat($condition, $conn)) {
			return false;
		} else {
			return true;
		}
	}

	function deleteGroupDataExe2($conn, $g_id) {
		//WHERE
		$where_st = "id = '".$this->escapeSqlString($g_id)."'";
			//set
		$set_st = "deleted =1";

		if (!$this->upDat($set_st, $where_st, $conn)) {
			return false;
		} else {
			return true;
		}
	}
}*/
/*
class CStudentTableAccess extends CTblAccess {
	function CStudentTableAccess () {
		$this->CTblAccess (STU_TBL);
	}

	function getDetailStudentData($conn, $id) {
		$condition = " WHERE id = '".$this->escapeSqlString($id)."'";
		$result = $this->getList("*", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result[0];
		}
	}

	//
	function getStudentListByGroup($conn, $g_id) {
		$condition = " WHERE course = '".$this->escapeSqlString($g_id)."'";
		$result = $this->getList("id, userid,timemodified", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function getStudentCnt($conn, $g_id) {
		$condition = " WHERE course = '".$this->escapeSqlString($g_id)."'";
		$result = $this->getList("COUNT(id)", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result[0][0];
		}
	}


	function insertStudentDataExe($conn, $get_arr) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
		if (DB_TYPE=="postgres7") {
			$index_item = "id,";
			$index_value = "nextval('".STU_ID_SEQ."'), ";
		}

		$INS_ITEM = $index_item."userid, course";
		$INS_CON = $index_value;
		$INS_CON .= "'".$this->escapeSqlString($get_arr['userid'])."', '".$this->escapeSqlString($get_arr['course'])."'";

		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}	
	}

	function insertFromXExe($conn, $uid, $gid) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
		if (DB_TYPE=="postgres7") {
			$index_item = "id,";
			$index_value = "nextval('".STU_ID_SEQ."'), ";
		}

		$INS_ITEM = $index_item."userid, course";
		$INS_CON = $index_value;
		$INS_CON .= "'".$this->escapeSqlString($uid)."', '".$this->escapeSqlString($gid)."'";

		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}	
	}

	
}

class CTeacherTableAccess extends CTblAccess {
	function CTeacherTableAccess () {
		$this->CTblAccess (TEA_TBL);
	}

	function getTeacherListByGroup($conn, $g_id) {
		$condition = " WHERE course = '".$this->escapeSqlString($g_id)."'";
		$result = $this->getList("id, userid,timemodified", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result;
		}
	}

	function getTeacherCnt($conn, $g_id) {
		$condition = " WHERE course = '".$this->escapeSqlString($g_id)."'";
		$result = $this->getList("COUNT(id)", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result[0][0];
		}
	}



	function insertTeacherDataExe($conn, $get_arr) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
		if (DB_TYPE=="postgres7") {
			$index_item = "id,";
			$index_value = "nextval('".TEA_ID_SEQ."'), ";
		}

		$INS_ITEM = $index_item."userid, course";
		$INS_CON = $index_value;
		$INS_CON .= "'".$this->escapeSqlString($get_arr['userid'])."', '".$this->escapeSqlString($get_arr['course'])."'";

		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}	
	}
	function insertFromXExe($conn, $uid, $gid) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
		if (DB_TYPE=="postgres7") {
			$index_item = "id,";
			$index_value = "nextval('".TEA_ID_SEQ."'), ";
		}

		$INS_ITEM = $index_item."userid, course, timemodified";
		$INS_CON = $index_value;
		$INS_CON .= "'".$this->escapeSqlString($uid)."', '".$this->escapeSqlString($gid)."',".time();

		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}	
	}
}
*/
class CXGroupTableAccess extends CXTblAccess {
	var $detail_group;
	//xoopsΥ롼ѤΥ饹
	function CXGroupTableAccess() {
		$this->CXTblAccess (XGROUP_TBL);
	}
	
	function insertGroupExe($conn, $get_arr) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
/*		if (XDB_TYPE=="postgres7") {
			$index_item = "text_id,";
			$index_value = "nextval('".XCOURSE_ID_SEQ."'), ";
		}
*/
		$INS_ITEM = $index_item."name,description,group_type";

		$INS_CON = $index_value;
		//ƥ꡼ϥǥեȤǡ¾褦ˤ
		$INS_CON .= "'".$this->escapeSqlString($get_arr['name'])."'";
		$INS_CON .= ",'".$this->escapeSqlString($get_arr['description'])."'";
		$INS_CON .= ",'".XOG_DEF_TYPE."'";

		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}
	}

	function updateGroupDataExe($conn, $dat_arr, $group_id) {
		$where_st = "id = '".$this->escapeSqlString ($group_id)."'";
			//set
		$set_st = "fullname ='".$this->escapeSqlString ($dat_arr['fullname'])."', ";
		$set_st .= "short_name = '".$this->escapeSqlString ($dat_arr['shortname'])."'";
		
		if (!$this->upDat($set_st, $where_st, $conn)) {
			return false;
		} else {
			return true;
		}
	}
/*
	function getDetailGroupData($conn, $id) {
		$condition = " WHERE groupid = '".$this->escapeSqlString($id)."'";
		$result = $this->getList("*", $condition, $conn);
		if ($result == false) {
			return false;
		} else {
			return $result[0];
		}
	}
	*/
	function setDetailGroupData ($conn, $id) {
		//BooleanΥ롼ץǡ
		
		$condition = " WHERE groupid = '".$this->escapeSqlString($id)."'";
		
		if (!$this->setSelectedList("*", $condition, $conn)) {
			return false;
		}
		$this->detail_group = $this->getSelectedList();
		return true;
	}
	
	function getDetailGroupData () {
		//᤹
		return $this->detail_group[0];
	}
	
	
	function deleteGroupDataExe($conn, $id) {
		$condition = "id = '".$this->escapeSqlString($id)."'";
		if (!$this->delDat($condition, $conn)) {
			return false;
		} else {
			return true;
		}
	}

	function deleteGroupDataExe2($conn, $g_id) {
		//WHERE
		$where_st = "id = '".$this->escapeSqlString($g_id)."'";
			//set
		$set_st = "deleted =1";

		if (!$this->upDat($set_st, $where_st, $conn)) {
			return false;
		} else {
			return true;
		}
	}
}

class CSbGroupTableAccess extends CXTblAccess {
	function CSbGroupTableAccess () {
		$this->CXTblAccess (XSBGROUP_TBL);
	}
	
	function insertSbGroupExe ($conn,$get_arr) {
		
		$INS_ITEM = "xoops_group_id, moodle_course_id,";
		$INS_ITEM .= "create_time,update_time,name";
		$INS_CON = "";
	}
	function insFromGedit ($conn, $xid, $mid, $name, $desc) {
		//ܹԥġ뤫
		$index_item = "";
		$index_value="";
/*		if (XDB_TYPE=="postgres7") {
			$index_item = "sb_user_id,";
			$this->last_id = "sb_user_id";
			$index_value = "nextval('".USR_ID_SEQ."'), ";
		}
*/
		$INS_ITEM = $index_item."xoops_group_id,moodle_course_id,create_time, update_time, name,summary";
		$INS_CON = $index_value;
//˥Ǥ褦ˡȤꤢconfirmed1ˤ
		$INS_CON .= "'".$this->escapeSqlString($xid)."', '";
		$INS_CON .= $this->escapeSqlString($mid)."', ".time().",".time().",'";
		$INS_CON .= $this->escapeSqlString($name)."','";
		$INS_CON .= $this->escapeSqlString($desc)."'";
		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		}
		return true;
	}
}

class CXUsersTableAccess extends CXTblAccess {
	//xoopsΥ롼ѤΥ饹
	function CXUsersTableAccess() {
		$this->CXTblAccess (XUSR_TBL);
	}
	
	function insertUserExe($conn, $get_arr) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
/*		if (XDB_TYPE=="postgres7") {
			$index_item = "text_id,";
			$index_value = "nextval('".XCOURSE_ID_SEQ."'), ";
		}
*/
		$INS_ITEM = $index_item."name,uname,email,pass,rank,level";

		$INS_CON = $index_value;
		//ƥ꡼ϥǥեȤǡ¾褦ˤ
		$INS_CON .= "'".$this->escapeSqlString($get_arr['name'])."'";
		$INS_CON .= ",'".$this->escapeSqlString($get_arr['uname'])."'";
		$INS_CON .= ",'".$this->escapeSqlString($get_arr['email'])."'";
		$INS_CON .= ",'".$this->escapeSqlString($get_arr['pass'])."'";
		$INS_CON .= ",'".$this->escapeSqlString($get_arr['rank'])."'";
		$INS_CON .= ",1";

		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}
	}
	function insertFromMExe($conn, $uname, $name, $pass, $email,$is_tea) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
/*		if (XDB_TYPE=="postgres7") {
			$index_item = "text_id,";
			$index_value = "nextval('".XCOURSE_ID_SEQ."'), ";
		}
*/
		$rank = 0;
		//ξˤRANKꤷƤ
		if ($is_tea == "tea") $rank = MOTEA_DEF_RANK;
		$INS_ITEM = $index_item."name,uname,email,pass,rank,level,user_sig,bio,user_regdate";

		$INS_CON = $index_value;
		//ƥ꡼ϥǥեȤǡ¾褦ˤ
		$INS_CON .= "'".$this->escapeSqlString(mb_convert_encoding($name,XHTML_ENCODE,MHTML_ENCODE))."'";
		$INS_CON .= ",'".$this->escapeSqlString(mb_convert_encoding($uname,XHTML_ENCODE,MHTML_ENCODE))."'";
		$INS_CON .= ",'".$this->escapeSqlString(mb_convert_encoding($email,XHTML_ENCODE,MHTML_ENCODE))."'";
		$INS_CON .= ",'".$this->escapeSqlString(mb_convert_encoding($pass,XHTML_ENCODE,MHTML_ENCODE))."'";
		$INS_CON .= ",'".$rank."'";
		$INS_CON .= ",1,'','',".time();
		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}
	}
	function updateUserMTExe($conn, $uid) {
		//MOODLE鶵Ͽݤ˥åץǡ
		$where_st = " rank < 1 AND uid = '".$this->escapeSqlString ($uid)."'";
			//set
		$set_st = "rank ='".MOTEA_DEF_RANK."' ";
		
		if (!$this->upDat($set_st, $where_st, $conn)) {
			return false;
		} else {
			return true;
		}
	}

}

class CXLinkAccess extends CXTblAccess {
	function CXLinkAccess () {
		$this->CXTblAccess (XLINK_TBL);
	}
	
	function insertLinkExe($conn, $get_arr) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
/*		if (XDB_TYPE=="postgres7") {
			$index_item = "text_id,";
			$index_value = "nextval('".XCOURSE_ID_SEQ."'), ";
		}
*/
		$INS_ITEM = $index_item."uid, groupid";

		$INS_CON = $index_value;
		//ƥ꡼ϥǥեȤǡ¾褦ˤ
		$INS_CON .= "'".$this->escapeSqlString($get_arr['userid'])."'";
		$INS_CON .= ",'".$this->escapeSqlString($get_arr['groupid'])."'";

		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		} else {
			return true;
		}
	}
	function insertFromMExe($conn, $uid, $gid) {
		//mySqlpostgresΰ㤤Ф
		$index_item = "";
		$index_value="";
/*		if (XDB_TYPE=="postgres7") {
			$index_item = "text_id,";
			$index_value = "nextval('".XCOURSE_ID_SEQ."'), ";
		}
*/
		$INS_ITEM = $index_item."uid, groupid";

		$INS_CON = $index_value;
		//ƥ꡼ϥǥեȤǡ¾褦ˤ
		$INS_CON .= "'".$this->escapeSqlString($uid)."'";
		$INS_CON .= ",'".$this->escapeSqlString($gid)."'";

		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
		//	echo "aa";
			return false;
		} else {
		//	echo "aa";
			return true;
		}
	}
}


class CXSbUserAccess extends CXTblAccess {
	var $sb_users;
	function CXSbUserAccess () {
		$this->CXTblAccess (XSBUSR_TBL);
	}
	
	function insertFromXExe ($conn, $dat_arr) {
		$index_item = "";
		$index_value="";
/*		if (XDB_TYPE=="postgres7") {
			$index_item = "sb_user_id,";
			$this->last_id = "sb_user_id";
			$index_value = "nextval('".USR_ID_SEQ."'), ";
		}
*/
		$INS_ITEM = $index_item."xoops_usr_id,moodle_usr_id,create_time, update_time, name, password, email";
		$INS_CON = $index_value;
//˥Ǥ褦ˡȤꤢconfirmed1ˤ
		$INS_CON .= "'".$this->escapeSqlString($dat_arr['xid'])."', '";
		$INS_CON .= $this->escapeSqlString($dat_arr['mid'])."', ".time().",".time().",'";
		$INS_CON .= $this->escapeSqlString($dat_arr['name'])."', '";
		$INS_CON .= $this->escapeSqlString($dat_arr['pass'])."','".$this->escapeSqlString($dat_arr['email'])."'";
		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		}
		return true;
	}
	
	function insertFromMExe ($conn, $dat_arr) {
		$index_item = "";
		$index_value="";
/*		if (XDB_TYPE=="postgres7") {
			$index_item = "sb_user_id,";
			$this->last_id = "sb_user_id";
			$index_value = "nextval('".USR_ID_SEQ."'), ";
		}
*/
		$INS_ITEM = $index_item."xoops_usr_id,moodle_usr_id,create_time, update_time, 
		firstname, lastname, name, password, email";
		$INS_CON = $index_value;
//˥Ǥ褦ˡȤꤢconfirmed1ˤ
		$INS_CON .= "'".$this->escapeSqlString($dat_arr['xid'])."', '";
		$INS_CON .= $this->escapeSqlString($dat_arr['mid'])."', ".time().",".time().",'";
		$INS_CON .= $this->escapeSqlString(mb_convert_encoding($dat_arr['firstname'],XHTML_ENCODE,MHTML_ENCODE))."', '";
		$INS_CON .= $this->escapeSqlString(mb_convert_encoding($dat_arr['lastname'],XHTML_ENCODE,MHTML_ENCODE))."', '";
		$INS_CON .= $this->escapeSqlString(mb_convert_encoding($dat_arr['name'],XHTML_ENCODE,MHTML_ENCODE))."', '";
		$INS_CON .= $this->escapeSqlString(mb_convert_encoding($dat_arr['pass'],XHTML_ENCODE,MHTML_ENCODE))."','".$this->escapeSqlString($dat_arr['email'])."'";
		if (!$this->insDat($INS_ITEM, $INS_CON, $conn)) {
			return false;
		}
		return true;
	}
	
	function updateFromXExe ($conn, $dat_arr) {
	
	}
	
	function updateFromMExe ($conn, $dat_arr) {
	
	}
	
}
?>